# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---
device_type: kv260

job_name: {{ CI_JOB_NAME }}

timeouts:
  job:
    minutes: 120

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}

visibility: public

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/zynqmp-kria-starter-psa/idt_greengrass.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: GITLAB_PRIVATE_TOKEN
      header: "PRIVATE-TOKEN"
      dataset: minimal

secrets:
  ARTIFACTORY_PASS: ARTIFACTORY_PASS
  ARTIFACTORY_USER: ARTIFACTORY_USER
  AWS_ACCESS_KEY_ID: AWS_ACCESS_KEY_ID
  AWS_SECRET_ACCESS_KEY: AWS_SECRET_ACCESS_KEY

context:
  boot_character_delay: 30
  test_character_delay: 30
  extra_kernel_args: rootwait

actions:
# Flash firmware and distro images and reset the device
- deploy:
    timeout:
      minutes: 40
    to: flasher
    images:
      ImageA:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      ImageB:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      sd:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
        partition: 1
        format: ext4
        overlays:
          lava: true

- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 10
    method: minimal

# Boot until login prompt is reached
- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 10
    method: minimal
    reset: false
    auto_login:
      login_prompt: 'zynqmp-kria-starter-psa login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@zynqmp-kria-starter-psa:.+\$ '
      - '@zynqmp-kria-starter-psa:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

# KV260
- test:
    timeout:
      minutes: 3
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Sanity-Test
            description: 'Greengrass-Sanity-Test'
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - export GG_HOME={{ GG_HOME }}
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - sudo mkdir /tmp/idt
              - sudo chown -R cassini:cassini /tmp/idt
              - sudo parsec-tool create-rsa-key -s --key-name $IOT_KEY_NAME
              - sudo parsec-tool create-csr --key-name $IOT_KEY_NAME --cn $IOT_KEY_NAME >$GG_HOME/$IOT_KEY_NAME.csr
              - sudo chmod 755 $GG_HOME
              - sudo chown -R cassini:cassini $GG_HOME
        from: inline
        name: Greengrass-Sanity-Test
        path: inline/Greengrass-Sanity-Test.yaml

# Tester - Provision Device Under Test
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 3
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Provision-DUT
            description: "Greengrass Provision DUT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - |
                set +x && \
                . /lava-${LAVA_JOB_ID}/secrets && \
                aws configure set aws_access_key_id ${AWS_ACCESS_KEY_ID} && \
                aws configure set aws_secret_access_key ${AWS_SECRET_ACCESS_KEY} && \
                aws configure set region {{ AWS_DEFAULT_REGION }} && \
                set -x
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export THING_IP=$TARGET_DEVICE_IP
              - export IOT_KEY_NAME=rsa-signed-key-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_TE_ROLE_ALIAS={{ IOT_TE_ROLE_ALIAS }}
              - export IOT_TE_ROLE_POLICY_ALIAS={{ IOT_TE_ROLE_POLICY_ALIAS }}
              - export IOT_THING_POLICY={{ IOT_THING_POLICY }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - mkdir -p ${GG_HOME}
              - scp -o "StrictHostKeyChecking no" cassini@$THING_IP:$GG_HOME/$IOT_KEY_NAME.csr $GG_HOME/
              - /tester/scripts/iot_device_provision.sh
              - rm $GG_HOME/$IOT_KEY_NAME.csr
              - scp -o "StrictHostKeyChecking no" $GG_HOME/* cassini@$THING_IP:$GG_HOME/
        from: inline
        name: Greengrass-Provision-DUT
        path: inline/Greengrass-Provision-DUT.yaml

# KV260 - Start Greengrass with generated parameters
- test:
    timeout:
      minutes: 10
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Setup-DUT
            description: 'Greengrass Setup DUT'
            os:
              - oe
            scope:
              - functional
          run:
            steps:
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - export IOT_THING_GROUP={{ IOT_THING_GROUP }}
              - export AWS_DEFAULT_REGION={{ AWS_DEFAULT_REGION }}
              - export GG_HOME={{ GG_HOME }}
              - sudo systemctl stop greengrass
              - rm -rf ${GG_HOME}/logs/*
              - |
              - sudo -E java -Droot="${GG_HOME}" -Dlog.store=FILE -jar "${GG_HOME}/alts/init/distro/lib/Greengrass.jar"
                             --init-config "${GG_HOME}/generated_config.yml"
                             --trusted-plugin "${GG_HOME}/aws.greengrass.crypto.ParsecProvider.jar"
                             --aws-region "${AWS_DEFAULT_REGION}"
                             --thing-name "${IOT_THING_NAME}"
                             --thing-group-name "${IOT_THING_GROUP}"
                             --component-default-user ggc_user:ggc_group
                             --setup-system-service true
                             --start true
                             --provision false
              - |
                until
                  systemctl is-active --quiet greengrass
                do
                  sleep 15
                done
        from: inline
        name: Greengrass-Setup-DUT
        path: inline/Greengrass-Setup-DUT.yaml

# Tester - Run IoT device tester
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 60
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Run-IDT
            description: "Greengrass Run IDT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - |
                set +x && \
                . /lava-${LAVA_JOB_ID}/secrets && \
                aws configure set aws_access_key_id ${AWS_ACCESS_KEY_ID} && \
                aws configure set aws_secret_access_key ${AWS_SECRET_ACCESS_KEY} && \
                aws configure set region {{ AWS_DEFAULT_REGION }} && \
                set -x
              - export THING_IP=$TARGET_DEVICE_IP
              - export TARGET_MACHINE={{ MACHINE }}
              - export IDT_ROLE={{ IDT_ROLE }}
              - export TEST_TIMEOUT_MULTIPLIER=1
              - export TEST_SESSION_NAME=IDT-Session-{{ CI_JOB_ID }}
              - export IDT_ROLE_SESSION_DURATION={{ IDT_ROLE_SESSION_DURATION }}
              - /tester/scripts/generate_device_config.sh
              - lava-test-case cassini-greengrass-tests --shell "timeout --foreground 50m /tester/scripts/run_tests.sh"
              - export gg_report_path=$(find /tester/devicetester_greengrass_v2_linux/results/ -xdev -name GGV2Q_Report.xml)
              - |
                set +x; \
                . /lava-${LAVA_JOB_ID}/secrets && \
                jfrog config add \
                  --insecure-tls=true artifactory-aws \
                  --interactive=false \
                  --artifactory-url={{ ARTIFACTORY_URL }} \
                  --user=${ARTIFACTORY_USER} \
                  --password=${ARTIFACTORY_PASS}
              - set -x;
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "${gg_report_path}",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/greengrass-results/TEST-Greengrass-test-report.xml",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish --insecure-tls=true "${build_name}" "{{ CI_JOB_ID }}" --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard --insecure-tls=true "${build_name}" --max-builds=10 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
        from: inline
        name: Greengrass-Run-IDT
        path: inline/Greengrass-Run-IDT.yaml

# Tester - Cleanup
- test:
    docker:
      image: {{ IDT_GREENGRASS_IMAGE }}
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Greengrass-Cleanup-Tests
            description: "Greengrass Cleanup Tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - |
                set +x && \
                . /lava-${LAVA_JOB_ID}/secrets && \
                aws configure set aws_access_key_id ${AWS_ACCESS_KEY_ID} && \
                aws configure set aws_secret_access_key ${AWS_SECRET_ACCESS_KEY} && \
                aws configure set region {{ AWS_DEFAULT_REGION }} && \
                set -x
              - export IOT_THING_NAME=Device-Cassini-Greengrass-Thing-{{ MACHINE }}-{{ CI_JOB_ID }}
              - /tester/scripts/aws_cleanup.sh
        from: inline
        name: Greengrass-Cleanup-Tests
        path: inline/Greengrass-Cleanup-Tests.yaml
